{-# LANGUAGE TemplateHaskell #-}

import           Test.DocTest
import           Test.QuickCheck
import           Precursor

prop_OneIsOne :: Property
prop_OneIsOne = once (1 === (1 :: Integer))

return []

runTests :: IO Bool
runTests = $quickCheckAll

main :: IO Bool
main = do
  doctest [ "-isrc"
          , "src/Precursor.hs"
          , "src/Precursor/Control/Functor.hs"
          , "src/Precursor/Control/Applicative.hs"
          , "src/Precursor/Control/Alternative.hs"
          , "src/Precursor/Structure/Foldable.hs"
          , "src/Precursor/Structure/Traversable.hs"
          , "src/Precursor/Control/Category.hs"
          , "src/Precursor/Data/Bool.hs"
          , "src/Precursor/Data/Either.hs"
          , "src/Precursor/Control/Monad.hs"
          , "src/Precursor/Numeric/Num.hs"
          , "src/Precursor/Algebra/Semiring.hs"
          , "src/Precursor/Algebra/Semigroup.hs"
          , "src/Precursor/Algebra/Ring.hs"
          , "src/Precursor/Algebra/Monoid.hs"
          , "src/Precursor/Algebra/Eq.hs"
          , "src/Precursor/Algebra/Ord.hs"
          , "src/Precursor/Function.hs"
          , "src/Precursor/Data/Maybe.hs"
          , "src/Precursor/Data/Tuple.hs"
          , "src/Precursor/Data/List.hs"
          , "src/Precursor/Control/State.hs"
          , "src/Precursor/Data/Set.hs"
          , "src/Precursor/Data/Map.hs"
          , "src/Precursor/Control/Bifunctor.hs"
          , "src/Precursor/Debug.hs"
          , "src/Precursor/Text/Show.hs"
          , "src/Precursor/System/IO.hs"
          , "src/Precursor/Text/Text.hs"
          , "src/Precursor/Coerce.hs"
          , "src/Precursor/Algebra/Enum.hs" ]
  runTests
